hdu 4745 Two Rabbits (最长非连续回文子序列)

Two Rabbits

Time Limit: 10000/5000 MS (Java/Others)    Memory Limit: 65535/65535 K (Java/Others)
Total Submission(s): 681    Accepted Submission(s): 352


Problem Description
Long long ago, there lived two rabbits Tom and Jerry in the forest. On a sunny afternoon, they planned to play a game with some stones. There were n stones on the ground and they were arranged as a clockwise ring. That is to say, the first stone was adjacent to the second stone and the n-th stone, and the second stone is adjacent to the first stone and the third stone, and so on. The weight of the i-th stone is ai.

The rabbits jumped from one stone to another. Tom always jumped clockwise, and Jerry always jumped anticlockwise.

At the beginning, the rabbits both choose a stone and stand on it. Then at each turn, Tom should choose a stone which have not been stepped by itself and then jumped to it, and Jerry should do the same thing as Tom, but the jumping direction is anti-clockwise.

For some unknown reason, at any time , the weight of the two stones on which the two rabbits stood should be equal. Besides, any rabbit couldn't jump over a stone which have been stepped by itself. In other words, if the Tom had stood on the second stone, it cannot jump from the first stone to the third stone or from the n-the stone to the 4-th stone.

Please note that during the whole process, it was OK for the two rabbits to stand on a same stone at the same time.

Now they want to find out the maximum turns they can play if they follow the optimal strategy.
 

Input
The input contains at most 20 test cases.
For each test cases, the first line contains a integer n denoting the number of stones.
The next line contains n integers separated by space, and the i-th integer ai denotes the weight of the i-th stone.(1 <= n <= 1000, 1 <= ai <= 1000)
The input ends with n = 0.
 

Output
For each test case, print a integer denoting the maximum turns.
 

Sample Input
  
  
1 1 4 1 1 2 1 6 2 1 1 2 1 3 0
 

Sample Output
  
  
1 4 5
Hint
For the second case, the path of the Tom is 1, 2, 3, 4, and the path of Jerry is 1, 4, 3, 2. For the third case, the path of Tom is 1,2,3,4,5 and the path of Jerry is 4,3,2,1,5.
 

Source


思路:
转化为两段最长不一定连续回文子序列,就好找状态和方程了。为什么是两段呢?因为母序列是环状的。
dp[i][j]表示区间[i,j]中最长不一定连续回文子序列,那么有方程:
if(a[i]==a[j])  dp[i][j]=dp[i+1][j-1]+2;
else dp[i][j]=max(dp[i+1][j],dp[i][j-1]);
注意状态的先后顺序来决定怎样循环。

ps:其实还是想不通为什么这就是最大解,为什么不能存在一个不是回文序列的解稍稍大一点呢?大牛又能证明的给我留个言哈。

代码:
#include <iostream>
#include <cstdio>
#include <cstring>
#include <algorithm>
#include <cmath>
#include <string>
#include <map>
#include <stack>
#include <vector>
#include <set>
#include <queue>
//#pragma comment (linker,"/STACK:102400000,102400000")
#define maxn 1005
#define mod 1000000007
#define INF 0x3f3f3f3f
using namespace std;

typedef long long ll;
int n,m,ans;
int a[maxn];
int dp[maxn][maxn];

void solve()
{
    int i,j;
    memset(dp,0,sizeof(dp));
    for(i=1;i<=n;i++)
    {
        dp[i][i]=1;
    }
    for(i=n;i>=1;i--)
    {
        for(j=i+1;j<=n;j++)
        {
            if(a[i]==a[j]) dp[i][j]=dp[i+1][j-1]+2;
            else dp[i][j]=max(dp[i][j-1],dp[i+1][j]);
        }
    }
    ans=0;
    for(i=1;i<=n;i++)
    {
        ans=max(ans,dp[1][i]+dp[i+1][n]);
    }
}
int main()
{
    int i,j;
    while(scanf("%d",&n),n)
    {
        for(i=1;i<=n;i++)
        {
            scanf("%d",&a[i]);
        }
        solve();
        printf("%d\n",ans);
    }
    return 0;
}
/*
6
2 1 3 4 1 2
*/



 
  • 0
    点赞
  • 1
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值